#/usr/bin/perl
<<DOC; 
Nom : Rachid Belmouhoub
usage : perl bao3_treetagger.pl fichier_tag fichier_motif
DOC
#
use XML::XPath; # appel du module perl xpath, (libxml fait la mme chose mais faire attention aux noms car sont differents chez xpath)
# On vrifie le nombre d'arguments de l'appel au script ($0 : le nom du script)
if($#ARGV!=1){print "usage : perl $0 fichier_tag fichier_motif";exit;} # fichier-motif c'est patterns
# Enregistrement des arguments dans les variables idoines
my $tag_file= shift @ARGV; #shift fonction
my $patterns_file = shift @ARGV;
my @patterns;
my $nb_patterns=0;
my $nb_tokens=0;
#
open(PATTERNSFILE, $patterns_file) or die "can't open $patterns_file: $!\n";
# lecture du fichier contenant les motifs, un motif par ligne (par exemple : NOM ADJ)
while ($ligne = <PATTERNSFILE>) {
	# on supprime avec la fonction chomp un ventuel retour  la ligne
	chomp($ligne);
	# 
	$nb_patterns = push(@patterns,$ligne); #push rajoute dns un tableau a la suite du dernier enregistrempent, un nouveau enregistrement
}
# cration de l'objet XML::XPath pour explorer le fichier de sortie tree-tagger XML
my $xp = XML::XPath->new( filename => $tag_file ) or die "big trouble"; # 
#
# recherche des motifs dans le fichier de sortie treetagger xml
foreach my $pattern (@patterns){  
	# construction au moyen de la fonction split d'un tableau dont chaque lment a pour valeur  un token du motif recherch
	@tokens=split(/ /,$pattern); 
	my $match_file = "res_extract-".join('_', @tokens).".txt"; 
	open(MATCHFILE, ">$match_file") or die "can't open $match_file: $!\n"; 
	&extract_pattern(@tokens);
	close(MATCHFILE);
}
# routine d'extraction d'un motif
sub extract_pattern{  
	@tokenz=@_; # @_   ajouter my @tokenz pr la rendre locale et ici ele elle reste (nom,prep,nom) ce qui avant tait dans @tokens (nom,prep,nom)
	$first_token=shift @tokenz; # ici ce sera nom prep nom
	chomp($first_token);
	$search_path="//element/data[1][contains(text(),\"$first_token\")]"; 
	foreach my $token (@tokenz){# construction  recursive du chemin xpath correspondant au motif recherch
		chomp($token);
		$search_path.="/ancestor::element/following-sibling::element[1]/data[1][contains(text(),\"$token\")]";
	}
	# boucle sur les nuds reconnus du chemin xpath
	foreach my $noeud ( $xp->find($search_path)->get_nodelist ) {
		# initialisation du tableau des formes
		# on le fait ici pour des raisons videntes d'conomie de mmoire et donc de performance
		my @matching_tokens; #
		# on remonte d'un cran au nud  parent pour extraire la forme trouve
		# dans le cas d'un motif NOM ADJ, c'est la forme de l'adjectif qu'on atteint
		$noeud_tmp=$noeud->getParentNode; 
		$i=0;
		foreach (@tokens){ #on pourrait faire for au lieu de foreach
			$i++;	
			$motif=$noeud_tmp->getChildNode(3)->string_value; 
			$nb_tokens=unshift(@matching_tokens,$motif); 
			$motif="";

			@noeudtmp=$xp->find("./preceding-sibling::element[1]",$noeud_tmp)->get_nodelist; 
			$noeud_tmp=shift(@noeudtmp); #
		}
		# criture des rsultats dans un fichier en utilisant la fonction join, pratique !
		print MATCHFILE join(' ', @matching_tokens)."\n";
	}
}